<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.07.01 - Build 31.07.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
class Dekaden_Analyse {
public $cli_parameter = array(
	'debug_ausgabe'=>0,
	'konfiguration'=>'~/benutzer_beispiel.ini',
	'aktion'=>'',
	'station'=>'',
	'vergleich'=>'',
	'jahr'=>0,
	'typ'=>'roh',
	'bedingung'=>''
	);
public $datenreihen = array(
	'temperatur_max',
	'temperatur_mit',
	'temperatur_min',
	'luftdruck_mit',
	'feuchte_mit',
	'wind_mit',
	'sonne',
	'niederschlag',
/*	'wolken_6h',
	'wolken_12h',
	'wolken_18h',
	'wolken_mit',*/
	'%tropentag',
	'%sommertag',
	'%frosttag',
	'%eistag',
	'%tropennacht',
	'%regentag'
);
public $grundgeruest_werte = array();
public $grundgeruest_dekaden = array();
public $startzeit = 0;

	public function __construct(){
	global $einstellungen;
		foreach ( $this->datenreihen as $d )
		$this->grundgeruest_werte[$d] = 0;
		for ( $m = 1 ; $m <= 12 ; $m++ ){
			for ( $d = 1 ; $d <= 3 ; $d++ )
			$this->grundgeruest_dekaden[$m.'/'.$d] = $this->grundgeruest_werte;
		}
	$this->startzeit = microtime(true);
		foreach ( $GLOBALS['argv'] as $v ){
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'v' )
			$this->cli_parameter['debug_ausgabe'] = substr_count($v,'v');
			if ( substr($v,0,2) === '--' ){
			$v = explode('=',$v);
			$k = substr($v[0],2);
			unset($v[0]);
			$v = implode('=',$v);
				switch ( $k ){
				case 'station':
				$this->cli_parameter['station'] = preg_replace('/[^a-z]+/i','',$v);
				break;
				case 'vergleich':
				$this->cli_parameter['vergleich'] = preg_replace('/[^0-9,\-\*]+/','',$v);
					if ( $this->cli_parameter['vergleich'] === '*' )
					$this->cli_parameter['vergleich'] = '1700-'.date('Y',mktime(0,0,0,1,1,date('Y')-1));
				break;
				case 'jahr':
				$this->cli_parameter['jahr'] = intval($v);
				break;
				case 'typ':
				$this->cli_parameter['typ'] = ( in_array($v,array('text','html','xml'),true) || is_numeric($v) ) ? $v : 'roh';
				break;
				case 'bedingung':
				$this->cli_parameter['bedingung'] = preg_replace('/[^a-z0-9_\-<>= ]+/i','',$v);
				break;
				case 'konfiguration':
				$this->cli_parameter['konfiguration'] = 'file://'.preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				default:
				$this->cli_parameter['aktion'] = $k;
				break;
				}
			}
		}
	$makro = array('~/','%station%','%jahr%','%typ%','%aktion%','%paramhash%');
	$ersetzen = array(dirname(__FILE__).'/',$this->cli_parameter['station'],$this->cli_parameter['jahr'],
		$this->cli_parameter['typ'],$this->cli_parameter['aktion'],sprintf('%u',crc32(print_r($this->cli_parameter,true))));
	$this->cli_parameter['konfiguration'] = str_replace($makro,$ersetzen,$this->cli_parameter['konfiguration']);
	$this->LadeBenutzerdefinierteEinstellungen($einstellungen);
	$einstellungen['report']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['report']['ausgabe_datei_maske']);
	$einstellungen['grafik']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['grafik']['ausgabe_datei_maske']);
	$einstellungen['zwischenspeicher']['speicher_pfad'] = str_replace($makro,$ersetzen,$einstellungen['zwischenspeicher']['speicher_pfad']);
		if ( $einstellungen['rekorde']['monate_anzeigen'] === '*' )
		$einstellungen['rekorde']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
		if ( $einstellungen['wieselflink']['monate_anzeigen'] === '*' )
		$einstellungen['wieselflink']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
	$einstellungen['grafik']['diagramm_abstand'] = 50; // TODO: zur Zeit noch hart kodiert
	return true;
	}

	protected function LadeBenutzerdefinierteEinstellungen(&$einstellungen){
	$this->KonsolenAusgabe(__FUNCTION__.'()',3);
		if ( file_exists($this->cli_parameter['konfiguration']) ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Datei "'.$this->cli_parameter['konfiguration'].'" gefunden',3);
		$roh = parse_ini_file($this->cli_parameter['konfiguration']);
			foreach ( $roh as $schluessel=>$wert ){
			$teile = explode('.',$schluessel);
				switch ( sizeof($teile) ){
				case 2:
					if ( isset($einstellungen[$teile[0]][$teile[1]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]]);
							else
							$einstellungen[$teile[0]][$teile[1]] = $wert;
						}
					}
				break;
				case 3:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]] = $wert;
						}
					}
				break;
				case 4:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]] = $wert;
						}
					}
				break;
				}
			}
		}
		else
		return false;
	return true;
	}

	protected function BenutzerWertPruefen($alt,$neu){
		switch ( gettype($alt) ){
		case 'boolean':
		$neu = ( in_array($neu,array('true','yes','ja','1')) ) ? true : false;
		break;
		case 'integer':
		$neu = intval($neu);
		break;
		case 'string':
		// nix tun, string einfach weitergeben
		break;
		default:
		$neu = null;
		break;
		}
	return $neu;
	}

	protected function ErmittleVergleichsJahre($jahre,$station){
	global $einstellungen;
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$jahre,3);
	$verfuegbar = array(1700,(int)date('Y'));
	$zeitraum = array();
	$jahre = explode(',',$jahre);
		if ( extension_loaded('simplexml') ){
			if ( file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') ){
			$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
				if ( isset($manifest->zeitreihe) ){
				$manifest = explode(' ',$manifest->zeitreihe);
				$verfuegbar = array((int)substr($manifest[0],0,4),(int)substr($manifest[1],0,4));
				}
			}
		}
		foreach ( $jahre as $wert ){
			if ( strpos($wert,'-') ){
			$wert = explode('-',$wert);
				if ( sizeof($wert) !== 2 || !is_numeric($wert[0]) || !is_numeric($wert[1]) )
				continue;
				for ( $a = (int)$wert[0] ; $a <= (int)$wert[1] ; $a++ )
				$zeitraum[] = $a;
			}
			else
			$zeitraum[] = (int)$wert;
		}
		foreach ( $zeitraum as $schluessel=>$wert ){
			if ( $wert < min($verfuegbar) || $wert > max($verfuegbar) )
			unset($zeitraum[$schluessel]);
		}
		if ( preg_match('/^(\d+)\-(\d+)$/m',$this->cli_parameter['vergleich'],$vergleich) ){
			if ( (int)$vergleich[1] < min($verfuegbar) )
			$vergleich[1] = min($verfuegbar);
			if ( (int)$vergleich[2] > max($verfuegbar) )
			$vergleich[2] = max($verfuegbar);
		unset($vergleich[0]);
		$this->cli_parameter['vergleich'] = implode('-',$vergleich);
		}
	return array_unique($zeitraum);
	}

	protected function SchluesselWertNachString($daten){
	$ausgabe = '';
		foreach ( $daten as $schluessel=>$wert )
		$ausgabe .= $schluessel."='".$wert."' ";
	return rtrim($ausgabe);
	}

	protected function MakrosErsetzen(&$eingabe,$wert){
	global $einstellungen;
	$eingabe = str_replace('%w',$einstellungen['grafik']['breite'],$eingabe);
	$eingabe = str_replace('%h',$einstellungen['grafik']['hoehe'],$eingabe);
	$eingabe = str_replace('!!',$einstellungen['grafik']['diagramm_abstand']*2,$eingabe);
	$eingabe = str_replace('!',$einstellungen['grafik']['diagramm_abstand'],$eingabe);
	}

	protected function FiltereDatenNachDekaden(&$datensatz,&$daten_fertig,$jahre){
	global $einstellungen;
	$daten_temp = array();
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$dekade = $this->ErmittleDekade($daten['tag']);
		$schluessel = $daten['monat'].'/'.$dekade;
			if ( !isset($daten_temp[$schluessel]) )
			$daten_temp[$schluessel] = $this->grundgeruest_werte;
			foreach ( $this->datenreihen as $wert ){
				if ( $daten_temp[$schluessel][$wert] === 0 )
				$daten_temp[$schluessel][$wert] = array();
				if ( $daten[$wert] !== '-' )
				$daten_temp[$schluessel][$wert][] = $daten[$wert];
			}
		$tage_bearbeitet++;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
		foreach ( $daten_temp as $schluessel=>$daten ){
			foreach ( $this->datenreihen as $wert ){
				if ( sizeof($daten_temp[$schluessel][$wert]) === 0 )
				continue;
				if ( substr($wert,0,1) === '%' )
				$daten_fertig[$schluessel][$wert] = ceil( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]) * 10 );
				else
				$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]), 1);
			}
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function FiltereDatenNachJahre(&$datensatz,&$daten_fertig,$jahre){
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$daten_fertig[] = $daten;
		$tage_bearbeitet++;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function HoleRohDaten($station){
	global $einstellungen;
	$datensatz = array();
	$typ = $einstellungen['daten'][$this->cli_parameter['station']]['typus'];
		if ( extension_loaded('simplexml') && file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') )
		$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
	$this->KonsolenAusgabe(__FUNCTION__.'() Für Station '.$station.' mit dem Typ '.$typ,2);
	$letzter_satz = '00000000';
		switch ( $typ ){
		case 'dwd_kl2000':
			foreach ( $einstellungen['daten'][$station]['roh_daten'] as $datei ){
			$uuid = sprintf('%u',crc32($datei));
			$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.'.$uuid;
				if ( !file_exists($lokaler_pfad) ){
				$this->KonsolenAusgabe(__FUNCTION__.'() Roh-Datei konnte nicht im Zwischenspeicher gefunden werden',2);
				continue;
				}
			$pruefsumme = 'pruefsumme_'.$uuid;
				if ( isset($manifest) && isset($manifest->$pruefsumme) ){
					if ( sha1_file($lokaler_pfad) !== strval($manifest->$pruefsumme) )
					$this->KonsolenAusgabe('Die Roh-Datei wurde seit dem letzten Import verändert',2);
				}
			$roh = file($lokaler_pfad);
			$this->KonsolenAusgabe(__FUNCTION__.'() Lese Datei aus dem Zwischenspeicher '.basename($lokaler_pfad),2);
				if ( !is_array($roh) || sizeof($roh) < 10 )
				continue;
			$this->KonsolenAusgabe(__FUNCTION__.'() Gefundene Zeilen '.sizeof($roh),2);
				foreach ( $roh as $zeile ){
					if ( strlen($zeile) < 128 )
					continue;
				$satz = array(
				'jahr'=>(int)substr($zeile,7,4),
				'monat'=>(int)substr($zeile,11,2),
				'tag'=>(int)substr($zeile,13,2),
				'luftdruck_mit'=>(double)substr($zeile,37,5)/10,
				'temperatur_max'=>(double)substr($zeile,43,4)/10,
				'temperatur_min'=>(double)substr($zeile,48,4)/10,
				'temperatur_mit'=>(double)substr($zeile,78,4)/10,
				'feuchte_mit'=>(int)substr($zeile,130,2),
				'wind_mit'=>(int)substr($zeile,161,2),
				'sonne'=>(double)substr($zeile,195,3)/10,
/*				'wolken_6h'=>(int)substr($zeile,164,2),
				'wolken_12h'=>(int)substr($zeile,173,2),
				'wolken_18h'=>(int)substr($zeile,182,2),
				'wolken_mit'=>(double)substr($zeile,191,3)/10, */
				'niederschlag'=>(double)substr($zeile,246,3)/10,
				'%tropentag'=>0,
				'%sommertag'=>0,
				'%frosttag'=>0,
				'%eistag'=>0,
				'%tropennacht'=>0,
				'%regentag'=>0,
				);
				$this->RohDatenValidieren($satz);

					if ( $satz['temperatur_max'] >= 30 ){
					$satz['%tropentag'] = 1;
					$satz['%sommertag'] = 1;
					}
					elseif ( $satz['temperatur_max'] >= 25 )
					$satz['%sommertag'] = 1;

					if ( $satz['temperatur_max'] <= 0 ){
					$satz['%eistag'] = 1;
					$satz['%frosttag'] = 1;
					}
					elseif ( $satz['temperatur_min'] <= 0 )
					$satz['%frosttag'] = 1;

					if ( $satz['temperatur_min'] >= 20 )
					$satz['%tropennacht'] = 1;

					if ( $satz['niederschlag'] > 0 )
					$satz['%regentag'] = 1;

				$datensatz[] = $satz;
				$letzter_satz = sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']);
				}
			$this->KonsolenAusgabe(__FUNCTION__.'() Datei abgeschlossen',2);
			}
		break;
		}
	unset($roh,$satz);
	$verschnitt = intval(substr($letzter_satz,-2))%10;
		if ( $verschnitt !== 0 && !in_array(substr($letzter_satz,4),array('0228','0229')) && (int)substr($letzter_satz,-2) !== 31 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Verwerfe '.$verschnitt.' Tage, da die letzte Dekade unvollständig ist',2);
			for ( $i = 1 ; $i <= $verschnitt ; $i++ )
			array_pop($datensatz);
		$letzter_satz = array_pop($datensatz);
		$datensatz[] = $letzter_satz;
		$this->KonsolenAusgabe(__FUNCTION__.'() Der letzte Datensatz trägt das Datum "'.sprintf('%04d%02d%02d',$letzter_satz['jahr'],$letzter_satz['monat'],$letzter_satz['tag']).'"',2);
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze eingelesen und verarbeitet',2);
	return $datensatz;
	}

	protected function RohDatenValidieren(&$satz){
		if ( $satz['temperatur_max'] < -50 || $satz['temperatur_max'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_max'].'" bei "temperatur_max" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_max'] = '-';
		}
		if ( $satz['temperatur_min'] < -90 || $satz['temperatur_min'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_min'].'" bei "temperatur_min" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_min'] = '-';
		}
		if ( $satz['temperatur_mit'] < -50 || $satz['temperatur_mit'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_mit'].'" bei "temperatur_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_mit'] = '-';
		}
		if ( $satz['luftdruck_mit'] < 900 || $satz['luftdruck_mit'] > 1100 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['luftdruck_mit'].'" bei "luftdruck_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['luftdruck_mit'] = '-';
		}
		if ( $satz['feuchte_mit'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['feuchte_mit'].'" bei "feuchte_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['feuchte_max'] = '-';
		}
		if ( $satz['wind_mit'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wind_mit'].'" bei "wind_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wind_mit'] = '-';
		}
		if ( $satz['sonne'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['sonne'].'" bei "sonne" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['sonne'] = '-';
		}
		if ( $satz['niederschlag'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['niederschlag'].'" bei "niederschlag" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['luftdruck'] = '-';
		}
/*		if ( $satz['wolken_6h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_6h'].'" bei "wolken_6h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_6h'] = '-';
		}
		if ( $satz['wolken_12h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_12h'].'" bei "wolken_12h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_12h'] = '-';
		}
		if ( $satz['wolken_18h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_18h'].'" bei "wolken_18h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_18h'] = '-';
		}
		if ( $satz['wolken_mit'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_mit'].'" bei "wolken_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_mit'] = '-';
		}*/
	}

	public function KonsolenAusgabe($text,$gewicht){
		if ( intval($gewicht) <= $this->cli_parameter['debug_ausgabe'] ){
		echo '['.sprintf('%6.3f',round(microtime(true)-$this->startzeit,3)).'s ::';
		echo ' '.sprintf('%4.1f',round(memory_get_usage(true)/1048576,1)).' MiB ] ';
		echo $text;
		echo chr(10);
		}
		if ( (int)$gewicht === -1 )
		die();
	return true;
	}

	public function GPSNachLesbar($daten){
	$ausgabe = '';
	$daten = explode(' ',$daten);
	$ausgabe .= ( doubleval($daten[0]) > 0 ) ? (double)$daten[0].'N ' : (double)$daten[0].'S ';
	$ausgabe .= ( doubleval($daten[1]) > 0 ) ? (double)$daten[1].'E ' : (double)$daten[1].'W ';
	return rtrim($ausgabe);
	}

	public function ZeitstempelNachLesbar($datum){
	$tag = substr($datum,6);
	$monat = substr($datum,4,2);
	$jahr = substr($datum,0,4);
	return $tag.'. '.strftime('%B',strtotime('1999'.$monat.'01')).' '.$jahr;
	}

	public function ErmittleDekade($tag){
	$tag = intval($tag);
		if ( $tag < 11 )
		return 1;
		elseif ( $tag < 21 )
		return 2;
		else
		return 3;
	}

	public function DekadeNachString($daten,$monat='%b'){
	$daten = explode('/',$daten);
	$datum = mktime(0,0,0,$daten[0],1,2000);
	return strftime($monat,$datum).chr(10).$daten[1];
	}

	public function HoleVergleichsMittelDerJahre($station,$jahre){
	$this->KonsolenAusgabe('Berechne Vergleichsmittel der Station '.$station.' für '.$jahre,1);
	$datensatz = $this->HoleRohDaten($station);
	$daten = array();
	$jahre = $this->ErmittleVergleichsJahre($jahre,$station);
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahre);
	$this->KonsolenAusgabe('Vergleichsmittel wurde berechnet',2);
	return $daten;
	}

	public function HoleStationsDatenDesJahres($station,$jahr){
	$this->KonsolenAusgabe('Berechne Jahresdaten der Station '.$station.' für '.$jahr,1);
	$datensatz = $this->HoleRohDaten($station);
	$daten = array();
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Jahresdaten wurden berechnet',2);
	return $daten;
	}

	public function HoleRoheDatenDerJahre($station,$jahr){
	$this->KonsolenAusgabe('Berechne alle Daten der Station '.$station.' für '.$jahr,1);
	$datensatz = $this->HoleRohDaten($station);
	$daten = array();
	$jahr = $this->ErmittleVergleichsJahre($jahr,$station);
	$this->FiltereDatenNachJahre($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Daten wurden berechnet',2);
	return $daten;
	}

	public function BerechneYAchse($wert){
	global $einstellungen;
	$diagramm_hoehe = $einstellungen['grafik']['hoehe']-(2*$einstellungen['grafik']['diagramm_abstand']);
	$diagramm_mitte = ($diagramm_hoehe/2);
	$balken_hoehe = (abs($wert)/10)*$diagramm_mitte;
	$koordinaten = array($diagramm_mitte,$diagramm_mitte,0); // absolut, start, höhe
		if ( $wert < 0 ){
		$koordinaten[0] = $diagramm_mitte+$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte;
		$koordinaten[2] = $balken_hoehe;
		}
		elseif ( $wert > 0 ){
		$koordinaten[0] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[2] = $balken_hoehe;
		}
	$koordinaten[0] += $einstellungen['grafik']['diagramm_abstand'];
	$koordinaten[1] += $einstellungen['grafik']['diagramm_abstand'];
	$this->KonsolenAusgabe(__FUNCTION__.'() wert='.$wert.' coords='.implode(',',$koordinaten),3);
	return $koordinaten;
	}

	public function VektorGrafikPuffer($element,$attribute,$daten=''){
	global $einstellungen;
	static $warteschlange = array();
		if ( $element === '%' )
		return $warteschlange;
	$attribute_roh = $attribute;
	parse_str(str_replace(',','&',$attribute),$attribute);
		foreach ( $attribute as $schluessel=>$wert ){
			if ( in_array($schluessel,array('x','y','x1','x2','y1','y2','width','height'),true) ){
			preg_match('/^([0-9a-z!%]+)([\-\+]*[0-9a-z!%]*)$/D',$wert,$berechnen);
			array_walk($berechnen,array('Dekaden_Analyse','MakrosErsetzen'));
				if ( isset($berechnen[2]) && strlen($berechnen[2]) > 0 ){
				$operator = substr($berechnen[2],0,1);
				$berechnen[2] = substr($berechnen[2],1);
					if ( $operator === '+' )
					$berechnen[0] = $berechnen[1]+$berechnen[2];
					elseif ( $operator === '-' )
					$berechnen[0] = $berechnen[1]-$berechnen[2];
				}
				if ( !isset($berechnen[0]) )
				$berechnen[0] = $wert;
				if ( strlen($schluessel) <= 2 )
				$berechnen[0] += 0.5;
			$attribute[$schluessel] = $berechnen[0];
			}
			if ( $schluessel === 'style' && strpos($wert,'%fn') )
			$attribute[$schluessel] = str_replace('%fn',$einstellungen['grafik']['schriftart'],$attribute[$schluessel]);
			if ( $schluessel === 'style' && strpos($wert,'%fh') )
			$attribute[$schluessel] = str_replace('%fh',$einstellungen['grafik']['schriftart_ueberschrift'],$attribute[$schluessel]);
		}
		switch ( $element ){
		case 'line':
		$warteschlange[] = '<line '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'rect':
		$warteschlange[] = '<rect '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'text':
		$warteschlange[] = '<text '.$this->SchluesselWertNachString($attribute).'>'.$daten.'</text>';
		break;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() element='.$wert.' attr='.preg_replace('/[\x00-\x1f]+/','',$attribute_roh),3);
	return true;
	}

	public function VektorGrafikZeichnen(){
	global $einstellungen;
	$puffer = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
	<svg xmlns="http://www.w3.org/2000/svg"
	  xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:ev="http://www.w3.org/2001/xml-events"
	  version="1.1" baseProfile="full"
	  width="'.intval($einstellungen['grafik']['breite']+2).'px" height="'.intval($einstellungen['grafik']['hoehe']+2).'px">
		<defs>
		<linearGradient id="bg-gradient" y2="100%">
		<stop offset="0%" stop-color="rgb(240,240,240)"/>
		<stop offset="100%" stop-color="rgb(224,224,224)"/>
		</linearGradient>
		</defs>
	';
	$puffer = str_replace(chr(9),'',$puffer);
	$elemente = $this->VektorGrafikPuffer('%',null,null);
	$puffer .= implode(chr(10).chr(9),$elemente).chr(10);
	$puffer .= '</svg>';
	$groesse = file_put_contents($einstellungen['grafik']['ausgabe_datei_maske'],$puffer);
	$this->KonsolenAusgabe(__FUNCTION__.'() filesize='.$groesse,3);
	return true;
	}

}
?>
